% ClusterSize plot
function adjplot(A0,cidx0,fh,style)

n=length(cidx0);
nc=max(cidx0);

nnc0=zeros(nc,1);%NX^̃m[h
for i=1:nc
	nnc0(i)=length(find(cidx0==i));
end
[nnc Ic]=sort(nnc0,'descend');
clear nnc0 nnc

I=zeros(n,1);
cidx=zeros(n,1);
a=0;
for i=1:nc
	for j=1:n
		if Ic(i)==cidx0(j)
			a=a+1;
			cidx(a,1)=i;
			I(a,1)=j;
		end
	end
end


%[cidx I]=sort(cidx0);
A=A0(I,I);

if nargin<4
    style=0;
end

pos = zeros(nc+1,1);
for i=1:nc
    pos(i) = find(cidx==i,1,'first');
end
pos(nc+1)=n+1;
[I J]=find(A);

nd = zeros(nc);      % #dots in the square
for k=1:length(I)
    x = I(k);
    y = J(k);
    nd(cidx(x),cidx(y))=nd(cidx(x),cidx(y))+1;
end
ndmean = sum(sum(nd)) / (n*n-n);

for ix=1:nc
    for iy=1:nc
        w = pos(ix+1)-pos(ix);
        h = pos(iy+1)-pos(iy);
        if ix==iy
            nd(ix,iy) = nd(ix,iy) / (w*(w-1));
        else
            nd(ix,iy) = nd(ix,iy) / (w*h);
        end
    end
end
nd = log(nd / ndmean+1e-10);
ndmin = log(1/4);
ndmax = log(8);


pos1=pos;
if style==1
    for i=1:nc
        pos(i+1)=pos(i)+log(pos1(i+1)-pos1(i));
    end
elseif style==2
    for i=1:nc
        pos(i+1)=pos(i)+(pos1(i+1)-pos1(i));
    end
else
    for i=1:nc
        pos(i+1)=i+1;
    end
end


for ix=1:nc
    for iy=1:nc
        c = (ndmax -nd(ix,iy))/(ndmax-ndmin);
        c = max(0, min(1,c));
        x=pos(ix); y=pos(iy);
        w = pos(ix+1)-pos(ix);
        h = pos(iy+1)-pos(iy);
        rectangle('Position',[x, y, w, h],...
                  'FaceColor',[c c c],... 
                  'EdgeColor',[c c c],...
                  'Parent',fh)
    end
end
axis(fh, 'ij','equal','tight','on');
