function [A nodes]=edges2net(nodeA,nodeB,isdirected)
% convert edge list into a network
nodes = uniqueitems([nodeA;nodeB]);
n=length(nodes);
I = zeros(size(nodeA));
J = zeros(size(nodeA));
for k=1:length(nodeA)
    I(k) = find(strcmp(nodes,nodeA(k)));
    J(k) = find(strcmp(nodes,nodeB(k)));
end
A=sparse(I,J,1,n,n);
A = A - diag(diag(A));    % remove self-loops
if ~isdirected
    A = A | A';
end
