function [v lam]=eigmap(A,clu,B)

n = length(A);

D = diag(sum(A));%degree
DD = D;
DDD = D;
for i=1:n
    DD(i,i) = DD(i,i).^(-B);
    DDD(i,i) = DDD(i,i).^(-B/2);
end
O = DD*A;
Delta = sparse(size(A));
for i=1:n
    O_sum = 0;
    for k=1:n
        O_sum = O_sum + O(i,k);
    end
    for j=1:n
        if i==j
            Delta(i,j) = O_sum;
        else
            Delta(i,j) = 0;
        end
    end
end

L = Delta - DDD*A*DDD;

opts.issym=1; opts.isreal=1; opts.disp=0; %opts.tol=1e-10;

[v,lam,flag]=eigs(L,clu,'sa',opts);

if flag ~=0
    error('eigmap---Eigensolver failed!')
end
lam=diag(lam);


