function ix = components(A0)

A=A0-diag(diag(A0));
n=length(A);
ix=zeros(n,1);
deleted=zeros(n,1);
nleft = n;
nc=1;
ix(1)=nc;
while nleft
    expanded=1;
    while expanded
        expanded=0;
        for i=1:n
            if deleted(i), continue; end
            if ix(i)~=nc, continue; end    % expand component nc only
            [I J]=find(A(i,:));
            A(i,J)=0;
            A(J,i)=0;                      % delete node i
            deleted(i)=1;
            nleft=nleft-1;
            if length(J)>0
                expanded=1;
                ix(J)=nc;
            end
        end
    end
    nc=nc+1;
    for i=1:n
        if deleted(i), continue; end
        ix(i)=nc;
        break
    end
end

